/*
 * SimpleException.h
 *
 *  Created on: 12/mag/2011
 *      Author: bertini
 */

#ifndef SIMPLEEXCEPTION_H_
#define SIMPLEEXCEPTION_H_

#include <string>

class SimpleException : public std::exception {
public:
	explicit SimpleException(std::string problemDescription, std::string problemClassName = "", std::string fileName="", int fileLine = -1, bool fatal = false);
	virtual ~SimpleException() throw() { } // required by ~exception() throw() - see http://www.agapow.net/programming/cpp/looser-throw-specifier
	const char* what() const throw() { return msg.c_str(); }

	bool isFatal() const { return fatal; }
	int getLine() const { return fileLine; }
	std::string getFile() const { return fileName; }
	std::string getMessage() const { return msg;}

private:
   std::string msg;
   std::string fileName;
   int fileLine;
   bool fatal;
};

#endif /* SIMPLEEXCEPTION_H_ */
